#!/usr/bin/perl -w

  use esmith::config;
  use esmith::db;
  
  my %conf;
  tie %conf, 'esmith::config';

  my $DomainName = db_get(\%conf, "DomainName") || 'localhost';

  $allow_html_code = 0;
  &ReadEnvs;

  $deniedurl = $in{'DENIEDURL'};
  $categories = $in{'CATEGORIES'};
  $reason = $in{'REASON'};
  $user = $in{'USER'};
  $ip = $in{'IP'};
  $fbypasshash = $in{'GBYPASS'} ||''; # filter bypass hash - can be undefined
  $ibypasshash = $in{'GIBYPASS'} ||''; # infection bypass hash - can be undefined

  # $reason gives too much detail for banned phrases
  # in your custom .pl pages you can use one or more of $why, $phrase or $reason
  ($why,$phrase) = split(/\:/, $reason);

  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE>Cannot access Web address</TITLE>';
  print '<script language="javascript"> <!-- function action(url) { var form = document.forms[0]; form.action = url; form.submit(); } -->  </script>';
  print '</HEAD><BODY><center><table BORDER="0" WIDTH=65%><tr><td><H2>&nbsp;</H2><p>&nbsp;<p>&nbsp;<p>';
  print "<b><font color=\"#ff0000\">You cannot access the following Web address:</font></b><p>";

  print "<strong>$deniedurl</strong>";
  print "<P>$user The site you requested is blocked for the following reason: <p><b>$categories : $why</b>";
  #print "<P>$user The site you requested is blocked for the following reason: <p><b>$categories : $reason</b>";
  print '<P>You can :<p>';
  print " <a href=\"mailto:admin\@$DomainName?subject=Site review request &body=I would like access to $deniedurl because ...\">Submit a site review request</a> ";
  print " to your network administrator.<p>";

  if (length($fbypasshash) > 0)
  {
    print "<a href=\"$deniedurl".'?GBYPASS='."$fbypasshash\">Temporarily override filtering </a> on this computer.<br>";
    print "<i>(Note that your administrator may be notified that you've bypassed filtering.)</i><p>";
    print " Use your browser's ";
    print ' <a href="javascript:history.go(-1)">Back button</a> ';
    print 'or enter a different Web address to continue.';
    print '</td></tr></table></center></BODY></HTML>';
    exit;
  }
  elsif (length($ibypasshash) > 0)
  {
    print "<a href=\"$deniedurl".'?GIBYPASS='."$ibypasshash\">Override virus scan </a> and download file.<br>";
    print "<i>(Note that your administrator may be notified that you've bypassed filtering.)</i><p>";
    print " Use your browser's ";
    print ' <a href="javascript:history.go(-1)">Back button</a> ';
    print 'or enter a different Web address to continue.';
    print '</td></tr></table></center></BODY></HTML>';
    exit;
  }
  else
  {
    print " Use your browser's ";
    print ' <a href="javascript:history.go(-1)">Back button</a> ';
    print 'or enter a different Web address to continue.';
    print '</td></tr></table></center></BODY></HTML>';
    exit;
  }

sub ReadEnvs {
  local($cl, @clp, $pair, $name, $value);
  if ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {
    read(STDIN, $cl, $ENV{'CONTENT_LENGTH'} );
  }
  else {
    $cl = $ENV{'QUERY_STRING'};
  }
  @clp = split(/::/, $cl);
  foreach $pair (@clp) {
    ($name, $value) = split(/==/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<!--(.|\n)*-->//g;
    if ($allow_html_code != 1) {
      $value =~ s/<([^>]|\n)*>//g;
    }
    $in{$name} = $value;
  }
}




